function Chunk::onAdd(%this)
{
	%this.bricks = new SimSet();
}

function Chunk::onRemove(%this)
{
	%this.bricks.deleteAll();
	%this.bricks.delete();
}

function Chunk::onChunkCreated(%this)
{
	%world = %this.getGroup();

	if (!isObject(%world))
		return;

	%this.fileName = "config/chunks/" @ %this.x @ "_" @ %this.y @ ".chunk";

	if (isFile(%this.fileName))
	{
	}
}

function Chunk::isSolid(%this, %x, %y, %z)
{
	%x = ~~%x;
	%y = ~~%y;
	%z = ~~%z;

	if (%x < 0 || %x >= 16)
		return 0;

	if (%y < 0 || %y >= 16)
		return 0;

	if (%z < 0 || %z >= 256)
		return 1;

	%data = %this.data[%x, %y, %z];
	return isObject(%data) && !%data.transparent;
}

function Chunk::isHidden(%this, %x, %y, %z)
{
	for (%i = 0; %i < 6; %i++)
	{
		%k = %x;
		%l = %y;
		%m = %z;

		switch (%i % 3)
		{
			case 0: %k += %i >= 3 ? -1 : 1;
			case 1: %l += %i >= 3 ? -1 : 1;
			case 2: %m += %i >= 3 ? -1 : 1;
		}

		if (!%this.isSolid(%k, %l, %m))
			return 0;
	}

	return 1;
}

function Chunk::updateBrick(%this, %x, %y, %z)
{
	%x = ~~%x;
	%y = ~~%y;
	%z = ~~%z;

	if (%x < 0 || %x >= 16)
		return;

	if (%y < 0 || %y >= 16)
		return;

	if (%z < 0 || %z >= 256)
		return;

	%brick = %this.brick[%x, %y, %z];
	%data = %this.data[%x, %y, %z];

	if (isObject(%brick))
	{
		if (!isObject(%data) || %this.isHidden(%x, %y, %z))
		{
			%brick.delete();
			%this.brick[%x, %y, %z] = "";
		}
	}
	else if (isObject(%data) && !%this.isHidden(%x, %y, %z))
	{
		%world = %this.getGroup();

		%brick = new FxDTSBrick()
		{
			datablock = %data;
			position = %world.getBrickPosition(%this, %x, %y, %z);
			isPlanted = 1;
		};

		%this.brick[%x, %y, %z] = %brick;

		%this.bricks.add(%brick);
		BrickGroup_888888.add(%brick);

		%brick.setTrusted(1);
		%brick.plant();
	}
}

function Chunk::updateNeighborBricks(%this, %x, %y, %z)
{
	for (%i = 0; %i < 6; %i++)
	{
		%k = %x;
		%l = %y;
		%m = %z;

		switch (%i % 3)
		{
			case 0: %k += %i >= 3 ? -1 : 1;
			case 1: %l += %i >= 3 ? -1 : 1;
			case 2: %m += %i >= 3 ? -1 : 1;
		}

		%this.updateBrick(%k, %l, %m);
	}

	return 1;
}

function Chunk::set(%this, %data, %x, %y, %z)
{
	if (%y $= "" && %z $= "" && getWordCount(%x) == 3)
	{
		%y = getWord(%x, 1);
		%z = getWord(%x, 2);
		%x = getWord(%x, 0);
	}

	%x = ~~%x;
	%y = ~~%y;
	%z = ~~%z;

	if (%x < 0 || %x >= 16)
		return;

	if (%y < 0 || %y >= 16)
		return;

	if (%z < 0 || %z >= 256)
		return;

	if (isObject(%this.brick[%x, %y, %z]))
		%this.brick[%x, %y, %z].delete();

	%wasSolid = %this.isSolid(%x, %y, %z);
	%this.data[%x, %y, %z] = getBlockData(%data);
	%isSolid = %this.isSolid(%x, %y, %z);

	if (%this.generateDelay)
	{
		%this.schedule(%this.generateDelay * 4, "updateBrick", %x, %y, %z);
		%this.generateDelay++;
		return;
	}

	%this.updateBrick(%x, %y, %z);

	if (%wasSolid != %isSolid)
		%this.updateNeighborBricks(%x, %y, %z);
}