function generateChunk(%chunk)
{
	%chunk.generateDelay = 1;

	for (%x = 0; %x < 16; %x++)
	{
		for (%y = 0; %y < 16; %y++)
		{
			%height = getTerrainHeight((%chunk.x * 16 + %x) | 0, (%chunk.y * 16 + %y) | 0);
			%chunk.set("grass", %x, %y, %height);

			for (%z = %height - 1; %z >= 0; %z--)
				%chunk.set("dirt", %x, %y, %z);
		}
	}

	%chunk.generateDelay = 0;

	// for (%x = 0; %x < 16; %x++)
	// {
	// 	for (%y = 0; %y < 16; %y++)
	// 	{
	// 		for (%z = 0; %z < 20; %z++)
	// 		{
	// 			%chunk.updateBrick(%x, %y, %z);
	// 		}
	// 	}
	// }

	//generateChunkGround(%chunk, 0);
}

function generateChunkGround(%chunk, %i)
{
	if (!isObject(%chunk))
		return;

	%x = %i % 16;
	%y = mFloor((%i - %x) / 16);

	%height = getTerrainHeight((%chunk.x * 16 + %x) | 0, (%chunk.y * 16 + %y) | 0);
	%chunk.set("grass", %x, %y, %height);

	for (%z = %height - 1; %z >= 0; %z--)
		%chunk.set("dirt", %x, %y, %z);

	if (%i < 256)
		schedule(128, 0, generateChunkGround, %chunk, %i + 1);
}

function getTerrainHeight(%x, %y)
{
	%x *= 0.025125;
	%y *= 0.025125;

	%noise = $PerlinNoise.noise2D(%x, %y);
	return mFloor(16 + %noise * 12);
}